
// Project: webCDwriter - Network CD Writing
// Author: Jrg Haeger, 11.05.2001

class LoadProject extends Command
{
	private DirTreeNode CDRootNode;
	private SessionSizeView sizeView;

	public LoadProject(DirTreeNode CDRootNode, SessionSizeView sizeView)
	{
		this.CDRootNode = CDRootNode;
		this.sizeView = sizeView;
	}

	protected void addDir(DirTreeNode node, String path)
	{
		// skip slashes
		int i = 0;
		for (; path.charAt(i) == '/'; i++);
		path = path.substring(i);

		int next = path.indexOf("/");
		if (next < 0)
			return;

		String s1 = path.substring(0, next);
		String s2 = path.substring(path.indexOf("/"));
		System.out.println(s1);
		System.out.println(s2);

		i = 0;
		for (; i < node.getChildCount(); i++)
			if (node.getChildAt(i).toString().equals(s1))
				break;

		if (i < node.getChildCount())
			addDir((DirTreeNode)node.getChildAt(i), s2);
		else
		{
			DirTreeNode newNode = new DirTreeNode(s1);
			node.insert(newNode);
			addDir(newNode, s2);
		}
	}

	protected void addLink(DirTreeNode node, String path, File2 file)
	{
		// skip slashes
		int i = 0;
		for (; path.charAt(i) == '/'; i++);
		path = path.substring(i);

		int next = path.indexOf("/");
		if (next < 0)
		{
			node.insert(new DirTreeNode(file));
//			System.out.println("link -> " + file);
			sizeView.add(file);
			return;
		}

		String s1 = path.substring(0, next);
		String s2 = path.substring(path.indexOf("/"));
//		System.out.println(s1);
//		System.out.println(s2);

		i = 0;
		for (; i < node.getChildCount(); i++)
			if (node.getChildAt(i).toString().equals(s1))
				break;

		if (i < node.getChildCount())
			addLink((DirTreeNode)node.getChildAt(i), s2, file);
		else
		{
			DirTreeNode newNode = new DirTreeNode(s1);
			node.insert(newNode);
			addLink(newNode, s2, file);
		}
	}

	void processHint(String str)
	{
//		System.out.println("");
//		System.out.println(str);

		String str1 = "", str2 = "", str3 = "";
		int i = str.indexOf(" ");
		if (i < 0)
				str1 = str;
		else
		{
			str1 = str.substring(0, i);
			str = str.substring(i + 1);
			i = str.indexOf(" ");
			if (i < 0)
				str2 = str;
			else
			{
				str2 = str.substring(0, i);
				str3 = str.substring(i + 1);
			}
		}

		str2 = removeEscChars(str2);
		str3 = removeEscChars(str3);
//		System.out.println(str2);
//		System.out.println(str3);

		if (str1.equals("dir"))
			addDir(CDRootNode, str2);
		else
		if (str1.equals("link"))
		{
			File2 file;
			if (str3.startsWith("server:"))
				file = new ServerFile(str3.substring(7));
			else
				file = new SecFile(str3);
			addLink(CDRootNode, str2, file);
		}
		else
		if (str1.equals("type"))
		{
			if (str2.equals("audio"))
				Mode.type = Mode.audio;
			else
			if (str2.equals("image"))
			{
				Mode.makeImage = false;
				Mode.type = Mode.data;
			}
			else
			if (str2.equals("data"))
			{
				Mode.makeImage = true;
				Mode.type = Mode.data;
			}
		}
	}

	public void run()
	{
		execCommand("loadProject " + spaceToEsc(State.sessionID));
		super.run();
	}
}
