
// Project: webCDwriter - Network CD Writing
// Author: Jrg Haeger, 05.2001

import java.io.*;

public class SaveProject extends Command
{
	protected DataOutputStream outStream;
	DirTreeNode CDRootNode;

	public SaveProject(DirTreeNode CDRootNode)
	{
		outStream = CDcreator.outStream;
		this.CDRootNode = CDRootNode;
	}

	protected void putFile(String dirName, DirTreeNode node)
		throws java.io.IOException, CommandError
	{
		File file = node.getFile();
		String fileName = dirName + "/" + node.toString();

		String source = "";
		if (file instanceof ServerFile)
//			source = "server:";
			return;

		outStream.writeBytes("link "
			+ spaceToEsc(fileName) + " "
			+ source + spaceToEsc(file.getPath()) + "\n");
		readResult();
		if (!lastResultOK())
			throw new CommandError();
	}

	void putTree(String dirName, DirTreeNode node)
		throws java.io.IOException, CommandError
	{
		String dirName2;
		if (dirName.equals("/"))
			dirName2 = "";
		else
		{
			dirName2 = dirName + '/' + node.toString();
			if (node.isChanged())
			{
				outStream.writeBytes("dir "
					+ spaceToEsc(dirName2) + "\n");
				readResult();
				if (!lastResultOK())
					throw new CommandError();
			}
			else
				putFile(dirName, node);
		}

		if (node.isExpanded() || node.isChanged())
			for (int i = 0; i < node.getChildCount(); i++)
			{
				if (cancel)
					return;
				DirTreeNode child =
					(DirTreeNode)node.getChildAt(i);
				if (child.isLeaf())
				{
					if (node.isChanged())
						putFile(dirName2, child);
				}
				else
					putTree(dirName2, child);
			}
	}

	public void run()
	{
		// for netscape
		if (CDcreator.isNetscapeVM())
		try {
			netscape.security.PrivilegeManager
				.enablePrivilege("UniversalFileRead");
		}
		catch (Exception e) {
		}

		execCommand("saveProject "
			+ spaceToEsc(State.sessionID));

		String type = null;
		if (Mode.type == Mode.audio)
			type = "audio";
		else
		if (Mode.type == Mode.data)
			if (Mode.makeImage)
				type = "data";
			else
				type = "image";
		if (type != null)
			execCommand("type " + type);

		boolean error = false;
		try
		{
			putTree("/", CDRootNode);
		}
		catch (java.io.IOException e)
		{
			System.out.println("SaveProject: IOException");
		}
		catch (CommandError cmdErr)
		{
			error = true;
		}

		super.run();
	}
}
